Name: xymon
Version: 4.3.7
Release: 1%{?dist}.10
Group: Applications/System
URL: http://xymon.sourceforge.net/
License: GPLv2 with exceptions
#Source: xymon-4.3.7.tar.gz
Source: http://downloads.sourceforge.net/xymon/%{name}-%{version}%{?beta:-RC-%beta}.tar.gz
Source1: xymon-init.d
Source2: xymon.logrotate
Source3: xymon-client.init
Source4: xymon-client.default
Source5: xymonlocal.te
Source6: xymonlocal.pp
Source7: xymonlocal.mod
Summary: Xymon network monitor
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires: openldap-devel
BuildRequires: openssl-devel
BuildRequires: pcre-devel
BuildRequires: rrdtool-devel
# Not needed when building in mock as sed is already part of the chroot.
# BuildRequires: sed
Requires: httpd
Requires: ntp 
Requires: procps
Requires: rrdtool
#Requires: xymon-selinux
Conflicts: xymon-client

%description
Xymon (previously known as Hobbit) is a system for monitoring 
your network servers and applications. This package contains 
the server side of the Xymon package.

%package client
Summary: Xymon client reporting data to the Xymon server
Group: Applications/System
Requires: procps
Conflicts: xymon
#Requires: xymon-selinux

%description client
This package contains a client for the Xymon (previously known
as Hobbit) monitor. Clients report data about the local system to 
the monitor, allowing it to check on the status of the system 
load, filesystem utilisation, processes that must be running etc.

%package selinux
Summary:   SElinux support for Xymon
Group:     Applications/File
# Requires:  %name = %version-%release
Requires(post): policycoreutils
Requires(post): policycoreutils-python
#Requires(postun): policycoreutils
%if 0%{?fedora} >= 10 || 0%{?rhel} >= 6 || 0%{?centos} >= 6
BuildArch: noarch
%endif

%description selinux
Configures Xymon to run in SELinux enabled environments.

%prep

%setup -q
USEXYMONPING=y \
ENABLESSL=y \
ENABLELDAP=y \
ENABLELDAPSSL=y \
XYMONUSER=xymon \
XYMONTOPDIR=%{_libdir}/xymon \
XYMONVAR=%{_var}/lib/xymon \
XYMONHOSTURL=/xymon \
CGIDIR=%{_libdir}/xymon/cgi-bin \
XYMONCGIURL=/xymon-cgi \
SECURECGIDIR=%{_libdir}/xymon/cgi-secure \
SECUREXYMONCGIURL=/xymon-seccgi \
HTTPDGID=apache \
XYMONLOGDIR=%{_var}/log/xymon \
XYMONHOSTNAME=localhost \
XYMONHOSTIP=127.0.0.1 \
MANROOT=%{_mandir} \
INSTALLBINDIR=%{_libdir}/xymon/server/bin \
INSTALLETCDIR=%{_sysconfdir}/xymon \
INSTALLWEBDIR=%{_sysconfdir}/xymon/web \
INSTALLEXTDIR=%{_libdir}/xymon/server/ext \
INSTALLTMPDIR=%{_var}/lib/xymon/tmp \
INSTALLWWWDIR=%{_var}/lib/xymon/www \
./configure 

cat <<EOF >SELINUX.README
%{name}-selinux: SELinux support
EOF

%build
PKGBUILD=1 make

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
INSTALLROOT=%{buildroot} PKGBUILD=1 make install

install -D -m755 %{SOURCE1} %{buildroot}%{_sysconfdir}/init.d/xymon
install -D -m755 %{SOURCE3} %{buildroot}%{_sysconfdir}/init.d/xymon-client
sed -i 's!/usr/lib!%{_libdir}!' %{buildroot}%{_sysconfdir}/init.d/xymon
sed -i 's!/usr/lib!%{_libdir}!' %{buildroot}%{_sysconfdir}/init.d/xymon-client

install -D -m644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/xymon
install -D -m755 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/xymon-client

mkdir -p %{buildroot}%{_bindir}
cd %{buildroot}%{_bindir} && ln -sf ../lib/xymon/server/bin/{xymon,xymoncmd} .

mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
mv %{buildroot}%{_sysconfdir}/xymon/xymon-apache.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/xymon.conf
sed -i 's!^Alias /xymon/!Alias /xymon!' %{buildroot}%{_sysconfdir}/httpd/conf.d/xymon.conf

rmdir %{buildroot}%{_libdir}/xymon/client/tmp
cd %{buildroot}%{_libdir}/xymon/client && ln -sf /tmp tmp
rmdir %{buildroot}%{_libdir}/xymon/client/logs
cd %{buildroot}%{_libdir}/xymon/client && ln -sf ../../../..%{_var}/log/xymon logs
mv %{buildroot}%{_libdir}/xymon/client%{_sysconfdir}/xymonclient.cfg /tmp/xymonclient.cfg.$$
cat /tmp/xymonclient.cfg.$$ | sed -e 's!^XYMSRV=.*!include %{_var}/run/xymonclient-runtime.cfg!' | grep -v "^XYMSERVERS=" >%{buildroot}%{_libdir}/xymon/client%{_sysconfdir}/xymonclient.cfg
rm /tmp/xymonclient.cfg.$$

for os in aix darwin freebsd hp-ux irix netbsd openbsd osf1 sco_sv sunos unixware; do
    rm %{buildroot}%{_libdir}/xymon/client/bin/xymonclient-$os.sh
done

# Added selinux stuff FIXME  Verify that the selinux stuff is still correct for el6
mkdir -p %{buildroot}/%{_sysconfdir}/selinux/local-policy/
install -m 644 %SOURCE5 %{buildroot}/%{_sysconfdir}/selinux/local-policy/
install -m 644 %SOURCE6 %{buildroot}/%{_sysconfdir}/selinux/local-policy/
install -m 644 %SOURCE7 %{buildroot}/%{_sysconfdir}/selinux/local-policy/

# Make /usr/lib/xymon/server/etc/tasks.d as xymonlaunch looks for this on startup.
# Doing mkdir /usr/lib/xymon/server/etc/tasks.d fails. We need to do mkdir -p /etc/xymon/tasks.d
# The end resuld is the same and that works.
mkdir -p %{buildroot}%{_sysconfdir}/%{name}/tasks.d

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%pre
echo pre pre First Install
if [ $1 -eq 1 ] ; then # First Install
	echo pre First Install
    groupadd xymon || true
    getent passwd xymon >/dev/null || useradd -r -d %{_libdir}/xymon -s /sbin/nologin -c "Xymon" xymon 2>/dev/null || :
    /sbin/service httpd reload
    /sbin/chkconfig --add %{name} 2>/dev/null || :
fi

%preun
echo preun Final Removal
if [ "$1" -eq "0" ] ; then # Final removal
	echo Final Removal xymon
    /sbin/service %{name} stop 2>/dev/null || :
    /sbin/chkconfig --del %{name} 2>/dev/null || :
	chgrp root %{_localstatedir}/log/messages || :
	chmod 0600 %{_localstatedir}/log/messages || :
fi

%post
echo pre First Install
if [ $1 -eq 1 ] ; then # First Install
	# Change the group and perms of /var/log/messages so that xymon can read them.
	chgrp %{name} %{_localstatedir}/log/messages || :
	chmod 0640 %{_localstatedir}/log/messages || :
fi

%postun 
	echo pre postun upgrade 
if [ $1 -eq "1" ]; then # Do this section on upgrade.
	echo postun upgrade 
   /sbin/service %{name}-client condrestart >/dev/null 2>&1 || :
fi

%pre client
echo pre pre First Install Client
if [ "$1" -eq "1" ] ; then # First install
	echo pre First Install Client
    getent passwd xymon >/dev/null || useradd -r -d %{_libdir}/xymon -s /sbin/nologin -c "Xymon" xymon 2>/dev/null || :
    /sbin/chkconfig --add %{name}-client 2>/dev/null || :
fi

%preun client
echo pre Final Removal Client
if [ "$1" -eq "0" ] ; then # Final removal
	echo Final removal Client
    /sbin/service %{name}-client stop 2>/dev/null || :
    /sbin/chkconfig --del %{name}-client 2>/dev/null || :
    chgrp root %{_localstatedir}/log/messages || :
    chmod 0600 %{_localstatedir}/log/messages || :
fi

%post client
echo pre post First Install Client
if [ "$1" -eq "1" ] ; then # First install
	# Change the group and perms of /var/log/messages so that xymon can read them.
	chgrp %{name} %{_localstatedir}/log/messages || :
	chmod 0640 %{_localstatedir}/log/messages || :
fi

%postun client
	echo pre postun upgrade client
if [ $1 -eq "1" ]; then # Do this section on upgrade.
   /sbin/service %{name}-client condrestart >/dev/null 2>&1 || :
fi

%preun selinux
# Uninstall the selinux module.
	echo pre Upgrade or Final removal selinux
# Upgrade = 1 Final removal = 0
if [ "$1" -gt "0" ] ; then # Final removal
	echo Final removal selinux
    semodule -r %{name}local 2>/dev/null || :
	# We do not want to touch the base modules. I do not know why he did this.
    #semodule -b %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
fi

%post selinux
	echo pre First Install or upgrade selinux 
if [ "$1" -gt "1" ] ; then # First install Or Upgrade
	echo First Install or Upgrade selinux
	# Verified that we need the next line.
	/usr/sbin/setsebool -P httpd_can_network_connect on 2>/dev/null || :
	# Lines commented below with #% are from the orig spec file. I am not sure if these are correct.
	#% /usr/sbin/semanage fcontext -a -t httpd_sys_script_exec_t '%{_libdir}/xymon/cgi-bin(/.*)?' 2>/dev/null || :
	#% /usr/sbin/semanage fcontext -a -t httpd_sys_script_exec_t '%{_libdir}/xymon/cgi-secure(/.*)?' 2>/dev/null || :
	#% /usr/sbin/semanage fcontext -a -t httpd_sys_script_ro_t '%{_var}/lib/xymon/rrd(/.*)?' 2>/dev/null || :
	#% /usr/sbin/semanage fcontext -a -t httpd_sys_script_rw_t '%{_var}/lib/xymon/tmp(/.*)?' 2>/dev/null || :
	# Not sure if we need this but it will not hurt.
	/sbin/restorecon -R %{_libdir}/xymon %{_var}/lib/xymon || :

	# Install our custom selinux module
	semodule -i %{_sysconfdir}/selinux/local-policy/%{name}local.pp 2>/dev/null || :
fi

%files
%defattr(-, root, root, -)
%doc README README.CLIENT Changes* COPYING CREDITS RELEASENOTES
%config(noreplace) %{_sysconfdir}/httpd/conf.d/xymon.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/xymon
%dir %config %{_sysconfdir}/xymon
%dir %config %{_sysconfdir}/xymon/tasks.d
%config(noreplace) %{_sysconfdir}/xymon/alerts.cfg
%config(noreplace) %{_sysconfdir}/xymon/analysis.cfg
%config(noreplace) %{_sysconfdir}/xymon/cgioptions.cfg
%config(noreplace) %{_sysconfdir}/xymon/client-local.cfg
%config(noreplace) %{_sysconfdir}/xymon/combo.cfg
%config(noreplace) %{_sysconfdir}/xymon/graphs.cfg
%config(noreplace) %{_sysconfdir}/xymon/holidays.cfg
%config(noreplace) %{_sysconfdir}/xymon/hosts.cfg
%config(noreplace) %{_sysconfdir}/xymon/protocols.cfg
%config(noreplace) %{_sysconfdir}/xymon/rrddefinitions.cfg
%config(noreplace) %{_sysconfdir}/xymon/snmpmibs.cfg
%config(noreplace) %{_sysconfdir}/xymon/tasks.cfg
%config(noreplace) %{_sysconfdir}/xymon/xymonmenu.cfg
%config(noreplace) %{_sysconfdir}/xymon/xymonserver.cfg
%config %{_sysconfdir}/xymon/columndoc.csv
%{_sysconfdir}/xymon/web
%{_sysconfdir}/init.d/xymon
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*
%{_mandir}/man8/*
%dir %{_libdir}/xymon
%{_libdir}/xymon/cgi-*
%dir %{_libdir}/xymon/client
%dir %{_libdir}/xymon/client/bin
%dir %{_libdir}/xymon/client/logs
%dir %{_libdir}/xymon/client/tmp
%config(noreplace) %{_libdir}/xymon/client/etc
%{_libdir}/xymon/client/bin/msgcache
%{_libdir}/xymon/client/bin/orcaxymon
%{_libdir}/xymon/client/bin/xymon*
%{_libdir}/xymon/client/runclient.sh
%dir %{_libdir}/xymon/server
%dir %{_libdir}/xymon/server/bin
%dir %{_libdir}/xymon/server/etc
%dir %{_libdir}/xymon/server/download
%dir %{_libdir}/xymon/server/tmp
%dir %{_libdir}/xymon/server/web
%dir %{_libdir}/xymon/server/www
%{_libdir}/xymon/server/bin/*.cgi
%{_libdir}/xymon/server/bin/bb
%{_libdir}/xymon/server/bin/bbcmd
%{_libdir}/xymon/server/bin/bbdigest
%{_libdir}/xymon/server/bin/bbhostgrep
%{_libdir}/xymon/server/bin/bbhostshow
%{_libdir}/xymon/server/bin/beastat
%{_libdir}/xymon/server/bin/combostatus
%{_libdir}/xymon/server/bin/convertnk
%{_libdir}/xymon/server/bin/moverrd.sh
%{_libdir}/xymon/server/bin/rrdcachectl
%{_libdir}/xymon/server/bin/trimhistory
%{_libdir}/xymon/server/bin/xymon
%{_libdir}/xymon/server/bin/xymon-mailack
%{_libdir}/xymon/server/bin/xymon.sh
%{_libdir}/xymon/server/bin/xymoncfg
%{_libdir}/xymon/server/bin/xymoncmd
%{_libdir}/xymon/server/bin/xymonfetch
%{_libdir}/xymon/server/bin/xymongen
%{_libdir}/xymon/server/bin/xymongrep
%{_libdir}/xymon/server/bin/xymonlaunch
%{_libdir}/xymon/server/bin/xymonnet
%{_libdir}/xymon/server/bin/xymonpage
%{_libdir}/xymon/server/bin/xymonproxy
%{_libdir}/xymon/server/bin/xymonreports.sh
%{_libdir}/xymon/server/bin/xymond*
%{_libdir}/xymon/server/xymon.sh

%defattr(664, xymon, apache)
%config(noreplace) %{_sysconfdir}/xymon/critical.cfg
%config(noreplace) %{_sysconfdir}/xymon/critical.cfg.bak

%defattr(755, xymon, xymon, -)
%dir %{_var}/log/xymon

%defattr(-, xymon, xymon, -)
%dir %{_var}/lib/xymon
%dir %{_var}/lib/xymon/acks
%dir %{_var}/lib/xymon/data
%dir %{_var}/lib/xymon/disabled
%dir %{_var}/lib/xymon/hist
%dir %{_var}/lib/xymon/histlogs
%dir %{_var}/lib/xymon/hostdata
%dir %{_var}/lib/xymon/logs
%dir %{_var}/lib/xymon/rrd
%dir %{_var}/lib/xymon/tmp
%dir %{_var}/lib/xymon/www
%{_var}/lib/xymon/www/gifs
%{_var}/lib/xymon/www/help
%{_var}/lib/xymon/www/html
%{_var}/lib/xymon/www/menu
%{_var}/lib/xymon/www/notes
%{_var}/lib/xymon/www/wml

%defattr(775, xymon, apache, -)
%dir %{_var}/lib/xymon/www/rep
%dir %{_var}/lib/xymon/www/snap

%defattr(755, xymon, xymon, -)
%{_libdir}/xymon/server/ext
%{_libdir}/xymon/client/ext

%defattr(750, root, xymon, -)
%{_libdir}/xymon/client/bin/logfetch
%{_libdir}/xymon/client/bin/clientupdate

%defattr(4750, root, xymon, -)
%{_libdir}/xymon/server/bin/xymonping

%files client
%defattr(-, root, root, -)
%doc README README.CLIENT Changes* COPYING CREDITS RELEASENOTES
%config(noreplace) %{_sysconfdir}/sysconfig/xymon-client
%{_sysconfdir}/init.d/xymon-client
%dir %{_libdir}/xymon
%dir %{_libdir}/xymon/client
%dir %{_libdir}/xymon/client/bin
%dir %{_libdir}/xymon/client/logs
%dir %{_libdir}/xymon/client/tmp
%dir %{_libdir}/xymon/client/local/README
%config(noreplace) %{_libdir}/xymon/client/etc
%{_libdir}/xymon/client/bin/msgcache
%{_libdir}/xymon/client/bin/orcaxymon
%{_libdir}/xymon/client/bin/xymon*
%{_libdir}/xymon/client/runclient.sh

%defattr(755, xymon, xymon, -)
%dir %{_var}/log/xymon
%dir %{_libdir}/xymon/client/ext

%defattr(750, root, xymon, -)
%{_libdir}/xymon/client/bin/logfetch
%{_libdir}/xymon/client/bin/clientupdate

%files selinux
%defattr(-, root, root, -)
%doc SELINUX.README
%dir %{_sysconfdir}/selinux/local-policy
%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.te
%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.pp
%attr(664,root,root) %{_sysconfdir}/selinux/local-policy/%{name}local.mod

%changelog
* Sun Feb 19 2012 Tom Diehl <mock@tntechs.com> 4.3.7-1.tnt.10
- mv'd useradd routines to pre because when installing via anaconda
  the group does not get set to xymon on some directories. This breaks
  xymon and the client. Uninstalling and reinstalling by hand gets the
  groups right.

* Thu Dec 21 2011 Tom Diehl <mock@tntechs.com> 4.3.7-1.tnt.3
- Minor fixes selinux upgrade scripts.

* Thu Dec 21 2011 Tom Diehl <mock@tntechs.com> 4.3.7-1.tnt.2
- Minor fixes in the selinux policy and startup scripts.

* Thu Dec 20 2011 Tom Diehl <mock@tntechs.com> 4.3.7-1.tnt.1
- Inital release of xymon 4.3.7 for el5 and el6.
